"{ Package: 'stx:goodies/metacello/stx' }"

MetacelloVersionConstructor subclass:#MetacelloStXVersionConstructor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-St/X-Constructors'
!


!MetacelloStXVersionConstructor methodsFor:'api'!

repositories: aBlock
    self shouldNotImplement. "/use multiple repository:/repository:with:

    "Created: / 03-10-2012 / 10:43:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

repository: description username: username password: password
    self shouldNotImplement. "/ use repository:with:
"/    self root
"/        repository: description
"/        username: username
"/        password: password
"/        constructor: self

    "Created: / 03-10-2012 / 10:44:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

repository: anObject with: aBlock
    self root repository: anObject with: aBlock constructor: self

    "Created: / 03-10-2012 / 10:45:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

type: anObject
    "Defines repository type (for MetacelloStXRepositorySpec).
     Type must be one of #cvs, #svn or #git."

    self root type: anObject constructor: self

    "Created: / 03-10-2012 / 11:26:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

url: anObject
    "Defines repository type (for MetacelloStXRepositorySpec).
     Url may contain %(VAR) style variables that are expanded
     before URL is used. See MetacelloStXRepositorySpec>>documentation
     for details"

    self root url: anObject constructor: self

    "Created: / 03-10-2012 / 11:27:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MetacelloStXVersionConstructor methodsFor:'api callbacks'!

setRepository: aString withBlock: aBlock

        | spec |
        spec := 
                (self project repositorySpec)
                        name: aString;
                        yourself.
        self root repositories merge: spec.
        self with: spec during: aBlock

    "Created: / 03-10-2012 / 10:52:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setTypeWithBlock: aBlock

        | spec |
        (spec := self root getType) == nil
                ifTrue: [ 
                        spec := self project valueHolderSpec.
                        self root setType: spec ].
        self with: spec during: aBlock

    "Created: / 03-10-2012 / 11:38:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setTypeWithString: aString
    self root type: aString

    "Created: / 03-10-2012 / 11:38:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setUrlWithBlock: aBlock

        | spec |
        (spec := self root getUrl) == nil
                ifTrue: [ 
                        spec := self project valueHolderSpec.
                        self root setUrl: spec ].
        self with: spec during: aBlock

    "Created: / 03-10-2012 / 11:39:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setUrlWithString: aString
    self root url: aString

    "Created: / 03-10-2012 / 11:38:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MetacelloStXVersionConstructor methodsFor:'api spec callbacks'!

repositoryForVersion: packageName with: aBlockOrString
    aBlockOrString setRepository: packageName withInMetacelloConfig: self

    "Created: / 03-10-2012 / 10:47:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

typeForVersion: aBlockOrString
    aBlockOrString setTypeInMetacelloConfig: self

    "Created: / 03-10-2012 / 11:35:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

urlForVersion: aBlockOrString
    aBlockOrString setUrlInMetacelloConfig: self

    "Created: / 03-10-2012 / 11:35:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!MetacelloStXVersionConstructor class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !

